<?php

spl_autoload_register(function ($class) {
    $prefix = 'FormInModule';
    $base_dir = dirname(__FILE__).'/src';

    $len = strlen($prefix);
    if (strncmp($prefix, $class, $len) !== 0) return;
    $relative_class = substr($class, $len);
    $file = $base_dir . str_replace('\\', '/', $relative_class) . '.php';
    if (file_exists($file)) {
        require $file;
    }
});

class FormInModule {
    public static function getForm($form_id) {
        $container = \FormInModule\Services\ServiceContainer::getInstance();
        // custome callback-files
        $callback_file = $container->getParameter('data_dir').'/callback.php';
        if (file_exists($callback_file)) {
            include_once $callback_file;
        } 
        $controller = new \FormInModule\Controller\FormController($container);
        return $controller->outputAction($form_id);
    }
}

if (rex::isBackend() && isset($_GET['page']) && 0 === strpos($_GET['page'],'form_in_module')){
    rex_view::addJsFile(rex_url::addonAssets('form_in_module', 'backend.js'));
}

function form_in_module_sample_options($args) {
    return array('Erster', 'Zweiter', 'Dritter');
}
function form_in_module_sample_check2_validation($args) {
    if (is_array($args['value']) && 2 == count($args['value'])) {
        return '';
    } 
    return 'Select 2 options';
}
