<?php
namespace FormInModule\Controller;

class DataController 
{
    public $container;

    public function __construct($container) {
        $this->container = $container; 
    }

    public function listAction($form_id) {
        $form = $this->container->get('FormRepository')->find($form_id);
        $dir = $this->container->getParameter('data_dir').'/submissions/f'.$form->form_id;
        $data_list = is_dir($dir) ? scandir($dir) : array();
        return $this->container->get('RenderService')->render(
            'backend/data_list.php', array(
                'form' => $form,
                'data_list' => $data_list,
                'UrlService' => $this->container->get('UrlService'),
                'Translator' => $this->container->get('TranslatorService'),
            ));

    }
    public function detailAction($form_id_file) {
        list($form_id, $file) = explode('_', $form_id_file, 2);
        $form = $this->container->get('FormRepository')->find($form_id);
        $dir = $this->container->getParameter('data_dir').'/submissions/f'.$form_id;
        $data = unserialize(file_get_contents($dir.'/'.$file));
        return $this->container->get('RenderService')->render(
            'backend/data_detail.php', array(
                'form' => $form,
                'data' => $data,
                'UrlService' => $this->container->get('UrlService'),
                'Translator' => $this->container->get('TranslatorService'),
            ));

    }
    public function removeAction($form_id_file) {
        list($form_id, $file) = explode('_', $form_id_file, 2);
        $form = $this->container->get('FormRepository')->find($form_id);
        $dir = $this->container->getParameter('data_dir').'/submissions/f'.$form_id;
        unlink($dir.'/'.$file);
        header("Location: ". $this->container->get('UrlService')->getUrl('/data/list/'.$form_id));
        die();

    }
    public function removeAllAction($form_id) {
        $dir = $this->container->getParameter('data_dir').'/submissions/f'.$form_id;
        foreach (scandir($dir) as $f) {
            if (in_array($f, ['.','..'])) continue;
            unlink($dir.'/'.$f);
        }
        header("Location: ". $this->container->get('UrlService')->getUrl('/data/list/'.$form_id));
        die();

    }
}


