<?php
namespace FormInModule\Models;

class Form
{
    public $form_id;
    public $title = '';
    public $sendto = '';
    public $sendcc = '';
    public $sendbcc = '';
    public $confirmto = 0;
    public $callback = '';
    public $id = '';
    public $class = '';
    public $attributes = '';
    public $submitfeedback = '';
    public $confirmsubject = '';
    public $confirmbody = '';
    public $view = '';

    public function setFormData($data, $container) {
        $fs = $container->get('FilterService');
        if (isset($data['title'])) {
            $this->title = $fs->filterString($data['title']);
        }
        if (isset($data['id'])) {
            $this->id = $fs->filterString($data['id']);
        }
        if (isset($data['class'])) {
            $this->class = $fs->filterString($data['class']);
        }
        if (isset($data['attributes'])) {
            $this->attributes = $fs->filterString($data['attributes']);
        }
        if (isset($data['sendto'])) {
            $this->sendto = $fs->filterString($data['sendto']);
        }
        if (isset($data['sendcc'])) {
            $this->sendcc = $fs->filterString($data['sendcc']);
        }
        if (isset($data['sendbcc'])) {
            $this->sendbcc = $fs->filterString($data['sendbcc']);
        }
        if (isset($data['callback'])) {
            $this->callback = $fs->filterString($data['callback']);
        }
        if (isset($data['confirmto'])) {
            $this->confirmto = intval($data['confirmto']);
        } 
        if (isset($data['confirmbcc'])) {
            $this->confirmbcc = $fs->filterString($data['confirmbcc']);
        }

        if (isset($data['submitfeedback'])) {
            $this->submitfeedback = $fs->filterText($data['submitfeedback']);
        }
        if (isset($data['confirmsubject'])) {
            $this->confirmsubject = $fs->filterString($data['confirmsubject']);
        }
        if (isset($data['confirmbody'])) {
            $this->confirmbody = $fs->filterText($data['confirmbody']);
        }
        if (isset($data['view'])) {
            $this->view = $fs->filterString($data['view']);
        }
    }

    public function validate($container) 
    {
        $errors = array();
        if ('' == trim($this->title)) {
            $errors['title'] = 'Input required';
        }
        if ('' != trim($this->sendto)) {
            if (false === filter_var($this->sendto, FILTER_VALIDATE_EMAIL)) {
                $errors['sendto'] = 'Not valid';
            }
        }

        if ('' != trim($this->sendcc)){
            $a = explode(',', $this->sendcc);
            foreach ($a as $c) {
                if (false === filter_var($c, FILTER_VALIDATE_EMAIL)) {
                    $errors['sendcc'] = 'Not valid';
                    break;
                }
            }
        }
        if ('' != trim($this->sendbcc)){
            $a = explode(',', $this->sendbcc);
            foreach ($a as $c) {
                if (false === filter_var($c, FILTER_VALIDATE_EMAIL)) {
                    $errors['sendbcc'] = 'Not valid';
                    break;
                }
            }
        }
        

        return $errors;
    }

    public function getSubmitfeedback() {
        return $this->submitfeedback;
    }

}
